package cn.citycraft.ResFly;

import org.bukkit.Bukkit;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;

import com.bekvon.bukkit.residence.protection.FlagPermissions;

import cn.citycraft.PluginHelper.config.FileConfig;
import cn.citycraft.PluginHelper.utils.VersionChecker;
import cn.citycraft.ResFly.listen.PlayerListen;

public class ResFly extends JavaPlugin {

	public FileConfig config;
	public String pluginname;
	public String servername;

	public String getfullmsg(final String path) {
		return this.servername + this.pluginname + " " + getmessage(path);
	}

	public String getmessage(final String path) {
		return this.config.getMessage(path);
	}

	@Override
	public void onEnable() {
		final PluginManager pm = getServer().getPluginManager();
		final Plugin res = pm.getPlugin("Residence");
		if (this.config.getBoolean("ResFly.Enable", true)) {
			if (res != null && res.isEnabled()) {
				FlagPermissions.addFlag("fly");
				FlagPermissions.addResidenceOnlyFlag("fly");
				Bukkit.getPluginManager().registerEvents(new PlayerListen(this), this);
				getLogger().info("玩家领地飞行控制已加载!");
			} else {
				getLogger().info("未找到领地插件停止加载领地飞行!");
				pm.disablePlugin(this);
				return;
			}
		}
		new VersionChecker(this);
	}

	@Override
	public void onLoad() {
		this.config = new FileConfig(this);
		this.servername = getmessage("servername");
		this.pluginname = getmessage("pluginname");
	}

}
